*-----------------------------------------------------------
* Program    : Memory Card Game
* Written by : Preston Doherty
* Date       : 4/28/2013
*-----------------------------------------------------------
AQUA		EQU	$00CCCC00
BLACK		EQU	$00000000
BLUE		EQU	$00FF0000
CARDBACK	EQU	$0000007E
CREAM		EQU	$00000066
DARKBLUE	EQU	$007A0009
FUCHSIA		EQU	$00FF00FF
LTGRAY		EQU	$00C0C0C0
LIGHTGRAY	EQU	$00AEAEAE
GRAY		EQU	$00808080
DARKGRAY	EQU	$006A6A6A
TABLEGREEN	EQU	$00426E31
GREEN		EQU	$00008000
LIME		EQU	$0000FF00
MAROON		EQU	$00000080
NAVY		EQU	$00800000
OLIVE		EQU	$000066FF
PURPLE		EQU	$00800080
RED		EQU	$000000FF
TEAL		EQU	$00003366
WHITE		EQU	$00FFFFFF
YELLOW		EQU	$0000FFFF

NewGame_Prompt_Top	EQU		30
NewGame_Prompt_Left	EQU		100
NewGame_Prompt_Width	EQU		153
NewGame_Prompt_Height	EQU		60
NewGame_Prompt_Bottom   EQU		NewGame_Prompt_Top+NewGame_Prompt_Height
NewGame_Prompt_Right	EQU		NewGame_Prompt_Left+NewGame_Prompt_Width

NewGame_Text_Top	EQU		50
NewGame_Text_Left	EQU		145


Quit_Prompt_Top	        EQU		30
Quit_Prompt_Left	EQU		543
Quit_Prompt_Width	EQU		153
Quit_Prompt_Height	EQU		60
Quit_Prompt_Bottom      EQU             Quit_Prompt_Top+Quit_Prompt_Height
Quit_Prompt_Right       EQU             Quit_Prompt_Left+Quit_Prompt_Width

Quit_Text_Top		EQU		50
Quit_Text_Left		EQU		605

Card_Width		EQU		80
Card_Height		EQU		112
Card_Left		EQU		40
Card_Gap		EQU		10
Player_Card_Top		EQU		150
Player_Card_Bottom	EQU		Player_Card_Top+Card_Height 
Row_2_Top               EQU             Player_Card_Bottom+30
Row_2_Bottom            EQU             Row_2_Top+Card_Height
Row_3_Top               EQU             Row_2_Bottom+30 
Row_3_Bottom            EQU             Row_3_Top+Card_Height           
Row_4_Top               EQU             Row_3_Bottom+30
Row_4_Bottom            EQU             Row_4_Top+Card_Height        

Player_Card1_Left	EQU		Card_Left
Player_Card1_Right	EQU		Player_Card1_Left+Card_Width
Player_Card2_Left	EQU		Player_Card1_Right+Card_Gap
Player_Card2_Right	EQU		Player_Card2_Left+Card_Width
Player_Card3_Left	EQU		Player_Card2_Right+Card_Gap
Player_Card3_Right	EQU		Player_Card3_Left+Card_Width
Player_Card4_Left	EQU		Player_Card3_Right+Card_Gap
Player_Card4_Right	EQU		Player_Card4_Left+Card_Width
Player_Card5_Left	EQU		Player_Card4_Right+Card_Gap
Player_Card5_Right	EQU		Player_Card5_Left+Card_Width
Player_Card6_Left	EQU		Player_Card5_Right+Card_Gap
Player_Card6_Right	EQU		Player_Card6_Left+Card_Width
Player_Card7_Left	EQU		Player_Card6_Right+Card_Gap
Player_Card7_Right	EQU		Player_Card7_Left+Card_Width
Player_Card8_Left	EQU		Player_Card7_Right+Card_Gap
Player_Card8_Right	EQU		Player_Card8_Left+Card_Width

Table_Width		EQU		800
Table_Height		EQU		750

* Delay for hundredths of a second in param 1
DELAY	MACRO
	move.b  #23,d0				; trap task 23
	move.l  #\1,d1				; delay amount
	trap    #15				; run the task
	ENDM


DRAWRECT MACRO					; \1 = left,   \2 = top
						; \3 = width,  \4 = height
	MOVEM.L	D0-D4,-(SP)			; move registers to Stack
	MOVE.W	\1,D1				; move left into D1.W
	MOVE.W	\2,D2				; move top into D2.W
	MOVE.W	\1,D3				; move left into D3.W
	ADD.W	\3,D3				; add width to D3.W
	MOVE.W	\2,D4				; move top into D4.W
	ADD.W	\4,D4				; add height to D4.W
	MOVE.B	#87,D0				; i/o task to draw a rectangle
	TRAP	#15				; run the task
	MOVEM.L	(SP)+,D0-D4			; move registers back from Stack
	ENDM
* Draw text as a graphic
DRAWTEXT MACRO					; \1 = left,   \2 = top
						; \3 = null terminated string
	MOVEM.L	D0-D2/A1,-(SP)			; move registers to Stack
	MOVE.W	\1,D1				; move left coordinate into D1.W
	MOVE.W	\2,D2				; move top coordinate into D2.W
	LEA	\3,A1				; move the address of the string into A1
	MOVE.B	#95,D0				; print null terminated string with x,y coord
	TRAP	#15				; run the task
	MOVEM.L	(SP)+,D0-D2/A1			; move registers back from Stack
	ENDM


* Set i/o fill color
SETFILLCOLOR MACRO				; \1 = color value
	MOVEM.L	D0-D1,-(SP)			; move registers to Stack
	MOVE.L	\1,D1				; move the color into D1.L
	MOVE.B	#81,D0				; i/o task to set fill color
	TRAP	#15				; run the task
	MOVEM.L	(SP)+,D0-D1			; move registers back from Stack
	ENDM

* Set i/o pen color
SETPENCOLOR MACRO				; \1 = color value
	MOVEM.L	D0-D1,-(SP)			; move registers to Stack
	MOVE.L	\1,D1				; move the color into D1.L
	MOVE.B	#80,D0				; i/o task to set pen color
	TRAP	#15				; run the task
	MOVEM.L	(SP)+,D0-D1			; move registers back from Stack
	ENDM


	ORG	$1000
START:						; first instruction of program
        LEA     Array,A2
       
        MOVE.B	#33,D0				; set screen resolution
	MOVE.L	#(Table_Width<<16+Table_Height),D1	; Table resolution
	TRAP	#15				; run the task
	* Initialize IRQ vectors 
	MOVE.L	#mouseDownIRQ,$68		; IRQ2
	MOVE.B	#60,D0				; set mouse IRQ
	MOVE.W	#$0201,D1			; IRQ2 for mouse down
	TRAP	#15				; run the task
	
	BSR	ClearTable
        BSR     DrawTable
        
        SETFILLCOLOR #TABLEGREEN		; set fill color
        MOVE.L  #$00400000,D1
        move.l  #$00500000,D2 
        move.b  #21,d0
        trap    #15     large font
        LEA     Title,A1
        move.w  #160,d1
        move.w  #50,d2
        move.b  #95,d0              place win message on screen
        trap    #15
        
        MOVE.L  #$00FFFFFF,D1
        move.l  #$00300000,D2 
        move.b  #21,d0
        trap    #15     large font
        LEA     Name,A1
        move.w  #50,d1
        move.w  #200,d2
        move.b  #95,d0              place win message on screen
        trap    #15
        
	LEA     Date,A1
        move.w  #50,d1
        move.w  #370,d2
        move.b  #95,d0              place win message on screen
        trap    #15
        
	MOVE.L  #$00FFFFFF,D1
        move.l  #$00200000,D2 
        move.b  #21,d0
        trap    #15     large font
        LEA     Class,A1
        move.w  #50,d1
        move.w  #300,d2
        move.b  #95,d0              place win message on screen
        trap    #15       
 
        move.l  #$00FFFFFF,D1
        move.l  #$00000000,D2 
        move.b  #21,d0
        trap    #15     large font  

        Delay   350

NewGame 
	BSR	ClearTable              
        BSR     DrawTable
        BSR     PromptForNewHand
        BSR     DisplayPlayerHand
        BSR	Shuffle
        * Pause while the player selects which cards to discard
	MOVE.L #2,D7				; set game position
	BSR	PauseForDiscard	
EXIT	
        MOVE.B	#9,D0
	TRAP	#15		; halt simulator

* Variables and Strings
Array   DC.B    1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16
NewGame_Prompt_Text	DC.B	'NEW GAME',0
Quit_Prompt_Text	DC.B	'QUIT',0
Gameover_Text           DC.B    'Game Over',0
Moves_Text              DC.B    'MOVES:',0
Name                    DC.B    'By Preston Doherty',0
Date                    DC.B    '5/1/2013',0
Class                   DC.B    'CIS 268 - Assembly Language',0
Title                   DC.B    'MEMORY MATCH',0

RX	DC.W 	1
RW	DC.W	1
RH	DC.W	1
RY	DC.W	1
FirstCard DC.B  1
SecondCard DC.B 1
Card1      DC.B 1
Card2      DC.B 1
TotalPairs DC.W 1
Moves      DC.L 0
MovesText  DC.W 1

discardArray	DS.B	5

InitializeGame			
        MOVE.B	#33,D0				; set screen resolution
	MOVE.L	#(Table_Width<<16+Table_Height),D1	; Table resolution
	TRAP	#15				; run the task
	* Initialize IRQ vectors 
	MOVE.L	#mouseDownIRQ,$68		; IRQ2
	MOVE.B	#60,D0				; set mouse IRQ
	MOVE.W	#$0201,D1			; IRQ2 for mouse down
	TRAP	#15				; run the task
	
	* Enable Exceptions
	MOVE.B	#32,D0				; Simulator Environment
	MOVE.B	#05,D1				; Enable Exceptions
	TRAP	#15				; run the task

	RTS

Shuffle
         MOVE.W  #0,D2
         MOVE.B  #0,D5
        for.w D5 = #0 to #20 do.s
For	
	CLR.L	D1
        BSR    GetRandomNumber
        CMP.W   #31,D2
        BGT     EndF
        MOVE.B  (A2,D4),D3
        MOVE.B  (A2,D2),(A2,D4)
        MOVE.B  D3,(A2,D2)
        ADD.W   #1,D2
        BRA     For
EndF
        endf
        RTS
        
DrawTable
	* Set the table color
	SETPENCOLOR  #TABLEGREEN		; set pen color
	SETFILLCOLOR #TABLEGREEN		; set fill color
	MOVE.W	#0,RX				; set X value
	MOVE.W	#0,RY				; set Y value
	MOVE.W	#Table_Width,RW			; set width
	MOVE.W	#Table_Height,RH		; set height
	DRAWRECT RX,RY,RW,RH
        RTS	

DisplayPlayerHand
	MOVE.W	#Player_Card_Top,RY		; set Y of cards
	SETPENCOLOR  #RED			; set pen color
	SETFILLCOLOR #CARDBACK			; set fill color
	BSR	PrintHandGfx			; print the hand graphics
	RTS
	
GetRandomNumber
	CLR	D4
       	MOVE.B	#8,D0				; return time in hundreds of a second
	TRAP	#15				; run the task
	AND.L	#$5FFFF,D1			; prevent overflow in divu
	DIVU	#32,D1				; time count / max number
	SWAP	D1				; swap upper and lower words of D1 to get remainder	
	EXT.L	D1				; convert lower word to long
	MOVE	D1,D4
	DELAY	1
	RTS



PrintHandGfx
	MOVE.W	#Card_Left,RX			; set X value of first card
	MOVE.W	#Card_Width,RW			; set width
	MOVE.W	#Card_Height,RH			; set height
	for.w D6 = #0 to #7 do.s		; loop 8 times
	  DRAWRECT RX,RY,RW,RH			;   draw card
	  MOVE.W #0,D1				;   clear D1.W
	  ADD.W #(Card_Width+Card_Gap),RX	;   shift the X value for next card
	endf					; end loop
	MOVE.W  #Row_2_Top,RY
	MOVE.W	#Card_Left,RX
	for.w D6 = #0 to #7 do.s		; loop 8 times
	  DRAWRECT RX,RY,RW,RH			;   draw card
	  MOVE.W #0,D1				;   clear D1.W
	  ADD.W #(Card_Width+Card_Gap),RX	;   shift the X value for next card
	endf
	MOVE.W  #Row_3_Top,RY
	MOVE.W	#Card_Left,RX
	for.w D6 = #0 to #7 do.s		; loop 8 times
	  DRAWRECT RX,RY,RW,RH			;   draw card
	  MOVE.W #0,D1				;   clear D1.W
	  ADD.W #(Card_Width+Card_Gap),RX	;   shift the X value for next card
	endf
	MOVE.W  #Row_4_Top,RY
	MOVE.W	#Card_Left,RX
	for.w D6 = #0 to #7 do.s		; loop 8 times
	  DRAWRECT RX,RY,RW,RH			;   draw card
	  MOVE.W #0,D1				;   clear D1.W
	  ADD.W #(Card_Width+Card_Gap),RX	;   shift the X value for next card
	endf


	RTS
	
PromptForNewHand
	*set prompt colors
	SETPENCOLOR	#WHITE
	SETFILLCOLOR	#BLACK
	
	*draw outer rectangle
	DRAWRECT	#NewGame_Prompt_Left,#NewGame_Prompt_Top,#NewGame_Prompt_Width,#NewGame_Prompt_Height
	;DRAWRECT	#(NewGame_Prompt_Left+220),#(NewGame_Prompt_Top+13),#NewGame_Prompt_Width,#(NewGame_Prompt_Height-30)
	*draw prompt text
	*draw outer rectangle
	DRAWRECT	#Quit_Prompt_Left,#Quit_Prompt_Top,#Quit_Prompt_Width,#Quit_Prompt_Height
        ;DRAWTEXT	#(NewGame_Text_Left+190),#(NewGame_Text_Top),Moves_Text
	DRAWTEXT	#NewGame_Text_Left,#NewGame_Text_Top,NewGame_Prompt_Text
	DRAWTEXT	#Quit_Text_Left,#Quit_Text_Top,Quit_Prompt_Text

	RTS
	
********************** IRQ HANDLERS ***********************************
* Special thanks to Daniel Strimpel and Chuck Kelly for providing
* this mouse handler function.

* Mouse Down handler
mouseDownIRQ
	if.b d7 <eq> #2 or d7 <eq> #4 then
	  movem.l	d0-d2,-(sp)
	  move.b	#61,d0			; read mouse
	  move.b	#2,d1			; mouse down state
	  trap		#15
	  clr.l		d2
	  move.w	d1,d2			; d2 is mouse X
	  swap		d1			; d1 is mouse Y
	  and.l		#$0FFFF,d1
	  	
	; if select cards
	  if.w d1 <hs> #Player_Card_Top and.w d1 <ls> #Player_Card_Bottom then
	    * select cards
	    * A3 = discardArray
	    
	    if.w d2 <hs> #Player_Card1_Left and.w d2 <ls> #Player_Card1_Right then
	      MOVE.B	#0,D0
	      if.b (A3,D0) <Ne> #1 then
                  MOVE.B  (A2,D0),D3
	          MOVE.B #1,(A3,D0)
	          MOVE.B    #0,D6
	          BSR	HighlightCards
	          BRA	ExitMD
	        endi
 	    endi
	    
	    * card 2
	    if.w d2 <hs> #Player_Card2_Left and.w d2 <ls> #Player_Card2_Right then
	      MOVE.B	#1,D0
	      if.b (A3,D0) <ne> #1 then
	      MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #1,D6
	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi
	    
	    * card 3
	    if.w d2 <hs> #Player_Card3_Left and.w d2 <ls> #Player_Card3_Right then
	      MOVE.B	#2,D0
	      if.b (A3,D0) <ne> #1 then
	      MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #2,D6
	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi
	    
	    * card 4
	    if.w d2 <hs> #Player_Card4_Left and.w d2 <ls> #Player_Card4_Right then
	      MOVE.B	#3,D0
	      if.b (A3,D0) <ne> #1 then
	      MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #3,D6
	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi
	    
	    * card 5
	    if.w d2 <hs> #Player_Card5_Left and.w d2 <ls> #Player_Card5_Right then
	      MOVE.B	#4,D0
	      if.b (A3,D0) <ne> #1 then
	      MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #4,D6
	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi
                * card 6
	    if.w d2 <hs> #Player_Card6_Left and.w d2 <ls> #Player_Card6_Right then
	      MOVE.B	#5,D0
	      if.b (A3,D0) <ne> #1 then
	      MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #5,D6
	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi
	    
	    * card 7
	    if.w d2 <hs> #Player_Card7_Left and.w d2 <ls> #Player_Card7_Right then
	      MOVE.B	#6,D0
	      if.b (A3,D0) <ne> #1 then
	      MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #6,D6
	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi
	    
	    * card 8
	    if.w d2 <hs> #Player_Card8_Left and.w d2 <ls> #Player_Card8_Right then
	      MOVE.B	#7,D0
	      if.b (A3,D0) <ne> #1 then
	      MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #7,D6
	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi

	  endi
	  
	  ; if select cards
	  if.w d1 <hs> #Row_2_Top and.w d1 <ls> #Row_2_Bottom then
	    * select cards
	    * A3 = discardArray
	    
	    * card 9
	    if.w d2 <hs> #Player_Card1_Left and.w d2 <ls> #Player_Card1_Right then
	      MOVE.B	#8,D0
	      if.b (A3,D0) <ne> #1 then
              MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #8,D6
	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi
	    
	    * card 10
	    if.w d2 <hs> #Player_Card2_Left and.w d2 <ls> #Player_Card2_Right then
	      MOVE.B	#9,D0
	      if.b (A3,D0) <ne> #1 then
              MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #9,D6
	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi
	    
	    * card 11
	    if.w d2 <hs> #Player_Card3_Left and.w d2 <ls> #Player_Card3_Right then
	      MOVE.B	#10,D0
	      if.b (A3,D0) <ne> #1 then
              MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #10,D6
	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi
	    
	    * card 12
	    if.w d2 <hs> #Player_Card4_Left and.w d2 <ls> #Player_Card4_Right then
	      MOVE.B	#11,D0
	      if.b (A3,D0) <ne> #1 then
	      MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #11,D6
	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi
	    
	    * card 13
	    if.w d2 <hs> #Player_Card5_Left and.w d2 <ls> #Player_Card5_Right then
	      MOVE.B	#12,D0
	      if.b (A3,D0) <ne> #1 then
              MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #12,D6
  	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi
                * card 14
	    if.w d2 <hs> #Player_Card6_Left and.w d2 <ls> #Player_Card6_Right then
	      MOVE.B	#13,D0
	      if.b (A3,D0) <ne> #1 then
	      MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #13,D6
  	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi
	    
	    * card 15
	    if.w d2 <hs> #Player_Card7_Left and.w d2 <ls> #Player_Card7_Right then
	      MOVE.B	#14,D0
	      if.b (A3,D0) <ne> #1 then
	      MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #14,D6
	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi
	    
	    * card 16
	    if.w d2 <hs> #Player_Card8_Left and.w d2 <ls> #Player_Card8_Right then
	      MOVE.B	#15,D0
	      if.b (A3,D0) <ne> #1 then
	      MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #15,D6
    	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi

	  endi

          ; if select cards
	  if.w d1 <hs> #Row_3_Top and.w d1 <ls> #Row_3_Bottom then
	    * select cards
	    * A3 = discardArray
	    
	    * card 17
	    if.w d2 <hs> #Player_Card1_Left and.w d2 <ls> #Player_Card1_Right then
	      MOVE.B	#16,D0
	      if.b (A3,D0) <ne> #1 then
	      MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #16,D6
  	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi
	    
	    * card 18
	    if.w d2 <hs> #Player_Card2_Left and.w d2 <ls> #Player_Card2_Right then
	      MOVE.B	#17,D0
	      if.b (A3,D0) <ne> #1 then
	      MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #17,D6
     	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi
	    
	    * card 19
	    if.w d2 <hs> #Player_Card3_Left and.w d2 <ls> #Player_Card3_Right then
	      MOVE.B	#18,D0
	      if.b (A3,D0) <ne> #1 then
	      MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #18,D6
    	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi
	    
	    * card 20
	    if.w d2 <hs> #Player_Card4_Left and.w d2 <ls> #Player_Card4_Right then
	      MOVE.B	#19,D0
	      if.b (A3,D0) <ne> #1 then
	      MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #19,D6
 	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi
	    
	    * card 21
	    if.w d2 <hs> #Player_Card5_Left and.w d2 <ls> #Player_Card5_Right then
	      MOVE.B	#20,D0
	      if.b (A3,D0) <ne> #1 then
	      MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #20,D6
   	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi
                * card 22
	    if.w d2 <hs> #Player_Card6_Left and.w d2 <ls> #Player_Card6_Right then
	      MOVE.B	#21,D0
	      if.b (A3,D0) <ne> #1 then
	      MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #21,D6
	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi
	    
	    * card 23
	    if.w d2 <hs> #Player_Card7_Left and.w d2 <ls> #Player_Card7_Right then
	      MOVE.B	#22,D0
	      if.b (A3,D0) <ne> #1 then
	      MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #22,D6
  	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi
	    
	    * card 24
	    if.w d2 <hs> #Player_Card8_Left and.w d2 <ls> #Player_Card8_Right then
	      MOVE.B	#23,D0
	      if.b (A3,D0) <ne> #1 then
	      MOVE.B #1,(A3,D0)
	      MOVE.B  (A2,D0),D3
	      MOVE.B    #23,D6
	      BSR	HighlightCards
	      BRA	ExitMD
	      endi
	    endi

	  endi

        ; if select cards
	  if.w d1 <hs> #Row_4_Top and.w d1 <ls> #Row_4_Bottom then
	    * select cards
	    * A3 = discardArray
	    
	    * card 25
	    if.w d2 <hs> #Player_Card1_Left and.w d2 <ls> #Player_Card1_Right then
	      MOVE.B	#24,D0
	      if.b (A3,D0) <ne> #1 then
	          MOVE.B #1,(A3,D0)  
	          MOVE.B  (A2,D0),D3
	          MOVE.B    #24,D6
 	          BSR	HighlightCards
	          BRA	ExitMD
	          endi
	    endi
	    
	    * card 26
	    if.w d2 <hs> #Player_Card2_Left and.w d2 <ls> #Player_Card2_Right then
	      MOVE.B	#25,D0
	      if.b (A3,D0) <ne> #1 then
	          MOVE.B #1,(A3,D0)
	          MOVE.B  (A2,D0),D3
	          MOVE.B    #25,D6
 	          BSR	HighlightCards
	          BRA	ExitMD
	          endi
	    endi
	    
	    * card 27
	    if.w d2 <hs> #Player_Card3_Left and.w d2 <ls> #Player_Card3_Right then
	      MOVE.B	#26,D0
	      if.b (A3,D0) <ne> #1 then
	          MOVE.B #1,(A3,D0)
	          MOVE.B  (A2,D0),D3
	          MOVE.B    #26,D6
	          BSR	HighlightCards
	          BRA	ExitMD
	          endi
	    endi
	    
	    * card 28
	    if.w d2 <hs> #Player_Card4_Left and.w d2 <ls> #Player_Card4_Right then
	      MOVE.B	#27,D0
	      if.b (A3,D0) <ne> #1 then
	          MOVE.B #1,(A3,D0)
	          MOVE.B  (A2,D0),D3
	          MOVE.B    #27,D6
	          BSR	HighlightCards
	          BRA	ExitMD
	          endi
	    endi
	    
	    * card 29
	    if.w d2 <hs> #Player_Card5_Left and.w d2 <ls> #Player_Card5_Right then
	      MOVE.B	#28,D0
	      if.b (A3,D0) <ne> #1 then
	          MOVE.B #1,(A3,D0)
	          MOVE.B  (A2,D0),D3
	          MOVE.B    #28,D6
 	          BSR	HighlightCards
	          BRA	ExitMD
	          endi
	    endi
                * card 30
	    if.w d2 <hs> #Player_Card6_Left and.w d2 <ls> #Player_Card6_Right then
	      MOVE.B	#29,D0
	      if.b (A3,D0) <ne> #1 then
	          MOVE.B #1,(A3,D0)
	          MOVE.B  (A2,D0),D3
	          MOVE.B    #29,D6
	          BSR	HighlightCards
	          BRA	ExitMD
	          endi
	    endi
	    
	    * card 31
	    if.w d2 <hs> #Player_Card7_Left and.w d2 <ls> #Player_Card7_Right then
	      MOVE.B	#30,D0
	      if.b (A3,D0) <ne> #1 then
	          MOVE.B #1,(A3,D0)
	          MOVE.B  (A2,D0),D3
	          MOVE.B    #30,D6
	          BSR	HighlightCards
	          BRA	ExitMD
	          endi
	    endi
	    
	    * card 32
	    if.w d2 <hs> #Player_Card8_Left and.w d2 <ls> #Player_Card8_Right then
	      MOVE.B	#31,D0
	      if.b (A3,D0) <ne> #1 then
	          MOVE.B #1,(A3,D0)
                  MOVE.B  (A2,D0),D3
                  MOVE.B    #31,D6
 	          BSR	HighlightCards
	          BRA	ExitMD
	          endi
	    endi

	  endi


	; if mouse inside quit button
	  if.w d1 <hi> #Quit_Prompt_Top and.w d1 <lo> #Quit_Prompt_Bottom then
            if.w d2 <hs> #Quit_Prompt_Left and.w d2 <ls> #Quit_Prompt_Right then 
              BRA 	EXIT
            endi
       	  endi
	; if mouse inside new game button
	  if.w d1 <hi> #NewGame_Prompt_Top and.w d1 <lo> #NewGame_Prompt_Bottom then
            if.w d2 <hs> #NewGame_Prompt_Left and.w d2 <ls> #NewGame_Prompt_Right then
              move.b	#9,d7
            endi
       	  endi
ExitMD
        CLR     D3
	  movem.l	(sp)+,d0-d2
	endi
	rte

HighlightCards
	* Draw discard button
	  if.b (A3,D6) <eq> #1 then 
            BSR SetColor
	    BSR DrawHighlight			; draw the highlighting
	  endi
	  if.b FirstCard <ne> #0 then
	    ADD.L  #1,Moves
	    MOVE.B D3,SecondCard
	    MOVE.B D6,Card2
	    BSR   CheckPair
	  else
	    ADD.L  #1,Moves
	    MOVE.B D6,Card1
	    MOVE.B D3,FirstCard
	  endi
	  
	RTS

*Draw the selected card highlight
DrawHighlight
  
	if.w D6 <eq> #0 then
	  DRAWRECT #(Player_Card1_Left),#(Player_Card_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #1 then
	  DRAWRECT #(Player_Card2_Left),#(Player_Card_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #2 then
	  DRAWRECT #(Player_Card3_Left),#(Player_Card_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #3 then
	  DRAWRECT #(Player_Card4_Left),#(Player_Card_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #4 then
	  DRAWRECT #(Player_Card5_Left),#(Player_Card_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #5 then
	  DRAWRECT #(Player_Card6_Left),#(Player_Card_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #6 then
	  DRAWRECT #(Player_Card7_Left),#(Player_Card_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #7 then
	  DRAWRECT #(Player_Card8_Left),#(Player_Card_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #8 then
	  DRAWRECT #(Player_Card1_Left),#(Row_2_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #9 then
	  DRAWRECT #(Player_Card2_Left),#(Row_2_Top),#(Card_Width),#(Card_Height)
	endi
        if.w D6 <eq> #10 then
	  DRAWRECT #(Player_Card3_Left),#(Row_2_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #11 then
	  DRAWRECT #(Player_Card4_Left),#(Row_2_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #12 then
	  DRAWRECT #(Player_Card5_Left),#(Row_2_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #13 then
	  DRAWRECT #(Player_Card6_Left),#(Row_2_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #14 then
	  DRAWRECT #(Player_Card7_Left),#(Row_2_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #15 then
	  DRAWRECT #(Player_Card8_Left),#(Row_2_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #16 then
	  DRAWRECT #(Player_Card1_Left),#(Row_3_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #17 then
	  DRAWRECT #(Player_Card2_Left),#(Row_3_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #18 then
	  DRAWRECT #(Player_Card3_Left),#(Row_3_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #19 then
	  DRAWRECT #(Player_Card4_Left),#(Row_3_Top),#(Card_Width),#(Card_Height)
	endi
        if.w D6 <eq> #20 then
	  DRAWRECT #(Player_Card5_Left),#(Row_3_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #21 then
	  DRAWRECT #(Player_Card6_Left),#(Row_3_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #22 then
	  DRAWRECT #(Player_Card7_Left),#(Row_3_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #23 then
	  DRAWRECT #(Player_Card8_Left),#(Row_3_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #24 then
	  DRAWRECT #(Player_Card1_Left),#(Row_4_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #25 then
	  DRAWRECT #(Player_Card2_Left),#(Row_4_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #26 then
	  DRAWRECT #(Player_Card3_Left),#(Row_4_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #27 then
	  DRAWRECT #(Player_Card4_Left),#(Row_4_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #28 then
	  DRAWRECT #(Player_Card5_Left),#(Row_4_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #29 then
	  DRAWRECT #(Player_Card6_Left),#(Row_4_Top),#(Card_Width),#(Card_Height)
	endi
        if.w D6 <eq> #30 then
	  DRAWRECT #(Player_Card7_Left),#(Row_4_Top),#(Card_Width),#(Card_Height)
	endi
	if.w D6 <eq> #31 then
	  DRAWRECT #(Player_Card8_Left),#(Row_4_Top),#(Card_Width),#(Card_Height)	
        endi
	
	RTS

*Pause the program
* D3 = 1 indicates mouse click on a button
* D4 = 0 for click on No, 1 for click on Yes
Pause
	DELAY		1			; delay for 1/100 seconds
	
	* Check for F8 Key to change game mode
	MOVE.B	#7,D0				; check for pending key press
	TRAP	#15				; run the task
	if.b D1 <ne> #0 then.s	; if key is ready and new hand prompt is displayed
	  MOVE.B #5,D0				;   read key
	  TRAP #15				;   run the task
	endi					; end if
	If D7 <eq> #9 then
	  BRA NewGame
	endi
	* Loop
	if D3 <ne> #1 then			; if mouse was not clicked
	  BRA		Pause			;   continue to loop
	endi					; end if
	RTS

*Handle discard routine
PauseForDiscard
	CLR.L	D3				;   clear D3 to await user input
	LEA	discardArray,A3			;   load discard array into A3
	BSR	Pause				;   pause for user input
	RTS

*Clear the table
* D0 = task holder
* D1 = information for task
ClearTable
	MOVE.B	#11,D0				; clear the screen
	MOVE.W	#$FF00,D1
	TRAP	#15				; run the task
	SETPENCOLOR  #WHITE			; set pen color
	SETFILLCOLOR #BLACK			; set fill color
	LEA	discardArray,A3			; load discard array into A3
	LEA     Moves_Text,A5
	for.w D6 = #0 to #31 do.s		; loop 32 times
	  MOVE.B #0,(A3,D6)			;   reset the discard array
	endf					; end if
	CLR.L	D0				; clear the registers
	CLR.L	D1
	CLR.L	D2
	CLR.L	D3
	CLR.L	D4
	CLR.L	D5
	CLR.L	D6
	MOVE.B  #0,FirstCard
	MOVE.B  #0,SecondCard
	MOVE.B  #0,Card1
	MOVE.B  #0,Card2
	MOVE.L  #0,Moves
	MOVE.W  #0,TotalPairs
	RTS

SetColor
        SETPENCOLOR  #WHITE			; set pen color
        if D3 <eq> #1 then
	SETFILLCOLOR #BLUE			; set fill color
	BRA ToEnd
        endi
        if D3 <eq> #2 then
	SETFILLCOLOR #RED			; set fill color
	BRA ToEnd
        endi
        if D3 <eq> #3 then
	SETFILLCOLOR #GREEN			; set fill color
	BRA ToEnd
        endi
        if D3 <eq> #4 then
	SETFILLCOLOR #PURPLE			; set fill color
	BRA ToEnd
        endi
        if D3 <eq> #5 then
	SETFILLCOLOR #YELLOW			; set fill color
	BRA ToEnd
        endi
        if D3 <eq> #6 then
	SETFILLCOLOR #NAVY			; set fill color
	BRA ToEnd
        endi
        if D3 <eq> #7 then
	SETFILLCOLOR #TEAL			; set fill color
	BRA ToEnd
        endi
        if D3 <eq> #8 then
	SETFILLCOLOR #FUCHSIA			; set fill color
	BRA ToEnd
        endi
        if D3 <eq> #9 then
	SETFILLCOLOR #DARKGRAY			; set fill color
	BRA ToEnd
        endi
        if D3 <eq> #10 then
	SETFILLCOLOR #LIME			; set fill color
	BRA ToEnd
        endi
        if D3 <eq> #11 then
	SETFILLCOLOR #White			; set fill color
	BRA ToEnd
        endi
        if D3 <eq> #12 then
	SETFILLCOLOR #AQUA			; set fill color
	BRA ToEnd
        endi
        if D3 <eq> #13 then
	SETFILLCOLOR #CREAM			; set fill color
	BRA ToEnd
        endi
        if D3 <eq> #14 then
	SETFILLCOLOR #OLIVE			; set fill color
	BRA ToEnd
        endi
        if D3 <eq> #15 then
	SETFILLCOLOR #LIGHTGRAY			; set fill color
	BRA ToEnd
        endi
        if D3 <eq> #16 then
	SETFILLCOLOR #BLACK			; set fill color
	BRA ToEnd
        endi
ToEnd 
        RTS

CheckPair
        CMP.B   FirstCard,D3
        BEQ     Match
        DELAY		50
        SETPENCOLOR #RED		; set pen color
	SETFILLCOLOR #CARDBACK		; set fill color
        MOVE.B  Card1,D6
	BSR     DrawHighlight			; draw the highlighting
	MOVE.B  Card2,D6
	BSR     DrawHighlight			; draw the highlighting
	MOVE.B  #0,(A3,D6)
	MOVE.B  Card1,D6
	MOVE.B  #0,(A3,D6)
	MOVE.B  #0,FirstCard
	MOVE.B  #0,SecondCard
	MOVE.B  #0,Card1
	MOVE.B  #0,Card2
        BRA     Skip 
Match   
        ADD.W   #1,TotalPairs
        BSR     CheckGameOver
        MOVE.B  #0,FirstCard
	MOVE.B  #0,SecondCard  
Skip  
        RTS
      
CheckGameOver
        CMP.W   #16,TotalPairs
        BNE     GoToEnd
	SETFILLCOLOR #BLACK		; set fill color
        MOVE.L  #$00FFFFFF,D1
        move.l  #$00400000,D2 
        move.b  #21,d0
        trap    #15     large font
        LEA     Gameover_text,A1
        move.w  #214,d1
        move.w  #250,d2
        move.b  #95,d0              place win message on screen
        trap    #15
        move.l  #$00FFFFFF,D1
        move.l  #$00000000,D2 
        move.b  #21,d0
        trap    #15     Normal font  
GoToEnd            
        RTS
	END	START		; last line of source
	















*~Font name~Courier New~
*~Font size~10~
*~Tab type~1~
*~Tab size~8~
